      Function ChkDlt(A,From,To)
C     Returns 
C     0 ... if nothing becomes zero
C     1 ... if exponent becomes zero, Denom is non-zero
C     2 ... if Denom becomes zero
C     after change of variables
      Use ModXpr
      Implicit None
      Type(Expression)                   :: A
      Type(Energy)                       :: EnExp
      Type(MomExp)                      :: To
      Type(Momentum) From
      Integer ChkDlt,j,i

      ChkDlt = 0
      EnExp = A%Exponent%Expi(1)
      Do j=1,EnExp%NumO
         Call ChangeVariables(EnExp%Energies(j)%Momentum,From,To)
      End Do
      Call OrderEnergy(EnExp)
      If(EnExp%NumO.eq.0) ChkDlt=1

      Do i=1,A%Denominator%NumDen
         EnExp = A%Denominator%Denom(i)
         Do j=1,EnExp%NumO
            Call ChangeVariables(EnExp%Energies(j)%Momentum,From,To)
         End Do
         Call OrderEnergy(EnExp)
         If(EnExp%NumO.eq.0) then
            ChkDlt=2
            Return
         End If
      End Do

      Return
      End
