      Function Forbid(Permut,Oper,UVE)
C     forbid permutation whose only effect is to change order of
C     long operators
      Use ModOpr
      Use ModUVE
      Implicit None
      Type(Operator) Oper
      Type(UVFunction) UVE
      Integer,Dimension(nmaxOp+nmaxUV) :: Permut
      Integer i
      Logical Forbid

      Forbid=.false.
      
C     Allow permutation if it changes places of short operators 
      Do i=1,Oper%NumOp
         If(Oper%OperG(i)%Argument%Length.gt.1) Cycle
         If(Oper%OperG(i)%Argument%Length.eq.1
     $   .and.Permut(i).eq.i) Cycle
         Return
      End Do

C     Allow permutation if it changes places of UV terms
      Do i=Oper%NumOp+1,Oper%NumOp+UVE%NumUVE
         If(Permut(i).eq.i)Cycle
         Return
      End Do

C     Do not allow permutation that changes order of long terms
      Do i=1,Oper%NumOp
         If(Oper%OperG(i)%Argument%Length.le.1) Cycle
         If(Oper%OperG(i)%Argument%Length.gt.1
     $   .and.Permut(i).eq.i) Cycle
         Forbid=.true.
         Return
      End Do
      Return
      End
