      Module Md1Enr
      Use ModMom
      Implicit None

      Type One_Energy
         Integer                              ::  Sign
         Character*(2)                        ::  Title
         Type(MomExp)                         ::  Momentum
      End Type One_Energy

      Interface Operator(.grth.)
         Module Procedure Greater_Than_OneEn
      End Interface
      Interface Operator(-)
         Module Procedure One_Change_Sign
      End Interface
      Interface Operator(.equal.)
         Module Procedure Equal_OneEn
      End Interface

      Contains
C############################################################
      Function Greater_Than_OneEn(A,B)
         Implicit None
         Type(One_Energy),Intent(In)   :: A,B
         Logical            :: Greater_Than_OneEn
     
         Greater_Than_OneEn=.false.
         If(A%Title.eq.'Om'.and.
     $     (B%Title.eq.'Os'.or.B%Title.eq.'Oz')) then
            Greater_Than_OneEn=.true.
            Return
         Else If(A%Title.eq.'Os'.and.B%Title.eq.'Oz') then
            Greater_Than_OneEn=.true.
            Return
         Else If((A%Title.eq.B%Title)
     $   .and.(A%Momentum .grth. B%Momentum)) then
            Greater_Than_OneEn=.true.
            Return
         Else If((A%Title.eq.B%Title)
     $   .and.(A%Momentum .equal. B%Momentum)
     $   .and.(A%Sign.gt.B%Sign)) then
            Greater_Than_OneEn=.true.
            Return
         End If        
      End Function Greater_Than_OneEn      
C############################################################
      Function Equal_OneEn(A,B)
         Type(One_Energy),Intent(In)        :: A,B
         Logical               :: Equal_OneEn

         Equal_OneEn = .false.
         If((.not.(A.grth.B)).and.(.not.(B.grth.A))) Equal_OneEn=.true.
      End Function Equal_OneEn
C############################################################
      Function One_Change_Sign(A)
         Implicit None
         Type(One_Energy),Intent(In)               :: A
         Type(One_Energy)               :: One_Change_Sign

         One_Change_Sign = A
         One_Change_Sign%Sign = -One_Change_Sign%Sign      
      End Function One_Change_Sign
C############################################################
      End Module Md1Enr
