      Subroutine Order1(IStaCr,ICurr,ExpR,Mode)
C     This program orders terms in the sequence of decreasing numbers
C     of operators.  The weight of operators decreases in the 
C     following order: A^,A_,B^,B_,C^,C_
      Use ModXpr
      Implicit None 
      Type(Expression), Dimension(NumExp)   :: ExpR,B
      Type(Expression) Find_Largest_Xpr
C     Internal arrays
      Integer i,m,IStaCr,ICurr,ii,Mode
      Integer IPrint
      COMMON /Print/ IPrint

      If(ICurr-IStaCr.le.0) Return
C     Remove zero terms
      ii=IStaCr-1
      Do i=IStaCr,ICurr
         If(ExpR(i)%IPowr(1).eq.0) Cycle
         ii=ii+1
         B(ii)=ExpR(i)
      End Do
      ICurr = ii

      Do i=IStaCr,ICurr
         ExpR(i)=Find_Largest_Xpr(B,m,IStaCr,ICurr,Mode)
         If(ExpR(i)%IPowr(1).eq.0) then
            ICurr=i-1
            Return
         End If
         If(IPrint.ge.9)
     $    Call Output(6,ExpR(i),'Final terms after ordering',i)
         B(m)%IPowr(1)=0
      End Do
      Return
      End

