C############################################################
      Function Find_Number(A)
C        Returns integer number corresponding to character A
         Use ModLet
         Implicit None
         Character      :: A,B
         Integer        :: Find_Number,i
         Character Azbuka(18)
         Common/Azb/ Azbuka
             
         Find_Number=0
         Do i=1,18
            If(A.eq.Azbuka(i)) then
               Find_Number=i
               Return
            End If
         End Do
         Write(6,*)'Warning!!! Cannot find number for a letter ',A
C        Segmentation fault to abort execution
         Call Abort()
      Return
      End 
C############################################################
      Subroutine ShrinkList(A)

C        Delete repeating characters from List A
         Use ModLet
         Implicit None
         Type(List)       :: A,B
         Integer i,j

         B%Length = A%Length
         Call AClear(B)
         j=0
         Do i=1,A%Length
            If(Index(B%Body(:B%Length),A%Body(i:i)).eq.0) then
               j=j+1
               B%Body(j:j)=A%Body(i:i)
            End If
         End Do
         B%Length = j
         A=B
      Return
      End
C############################################################
      Subroutine AClear(String)

C        Initialize string to blank
         Use ModLet
         Implicit None
         Type(List) String
         Integer i

         Do i=1,String%Length
            String%Body(i:i)=' '
         End Do
      Return
      End 
C############################################################
      Function Letter(Momen1,Momen2)

C        Find out if at least one letter from Momen1 is 
C        contained in Momen2. Then return .true.
         Use ModLet
         Implicit None
         Type(List)   :: Momen1,Momen2,Momen3
         Logical Letter
         Integer i,Ind
         Character*1 Azbuka(18)
         Common/Azb/ Azbuka

         Letter=.false.
         Momen3 = Momen2 - Momen1
         If(Momen3%Length.lt.Momen2%Length) Letter = .true.
      Return
      End 
C############################################################
      Function FindNewLetter(Momen1)

C        Find a letter that is not contained in Momen1,
C        Append Momen1 with this letter
         Use ModLet
         Implicit None
         Type(List)   :: Momen1,Let
         Character FindNewLetter
         Integer i
         Character Azbuka(18)
         Common/Azb/ Azbuka

         Do i=1,18
            If(Index(Momen1%Body(:Momen1%Length),Azbuka(i))
     $      .eq.0) then
               FindNewLetter = Azbuka(i)
               Let%Length=1
               Let%Body(1:1) = FindNewLetter
               Momen1 =Momen1 * Let
               Return
            End If
         End Do
         Write(6,*) ' Not enough letters in the alphabet!!!'
      Return
      End 
C############################################################
      Function IntToChar(i)
         Use ModLet
         Implicit None
         Integer i
         Character IntToChar

         If(i.eq.1) then
            IntToChar='+'
         Else If(i.eq.-1) then
            IntToChar='-'
         Else
            Write(6,*) 'Warning!!! Wrong Int'
         End If
      Return
      End 
C############################################################
      Function CharToInt(A)
         Use ModLet
         Implicit None
         Integer  CharToInt
         Character A

         If(A.eq.'+') then
            CharToInt = 1
         Else If(A.eq.'-') then
            CharToInt = -1
         Else
            Write(6,*) 'Warning!!! Wrong Char'
         End If
      Return
      End 
C############################################################
      Function Belongs(i,Array,Dim)
         Implicit None
         Integer i,j,Dim
         Integer,Dimension(Dim)  :: Array
         Logical Belongs

         Belongs=.false.
         Do j=1,Dim
            If(i.eq.Array(j)) then
               Belongs=.true.
               Return
            End If
         End Do
      Return
      End 
C############################################################
