C############################################################
       Subroutine OrdUVE(A)
         Use ModUVE
         Implicit None
         Type(UVFunction)            :: A
C        Internal array
         Type(UVFunction)            :: B
         Type(One_UVFunction) Find_Largest_UVE
         Integer k,m,IPrint
         COMMON /Print/ IPrint

C        Order momexps in UVER
C        Is it true that changing order of factors in UVE can
C        change the trace?

         Do k=1,A%NumUVE
            Call OrderMomExp(A%UVEG(k)%Argument)
         End Do   
         If(A%NumUVE.le.1) Return
         B = A
         Do k=1,A%NumUVE
            A%UVEG(k)=Find_Largest_UVE(B,m)
            B%UVEG(m)%Title='#'
         End Do
      Return
      End 
C############################################################
      Function Find_Largest_UVE(B,k)
         Use ModUVE
         Implicit None
         Type(UVFunction)   :: B
         Integer            :: k,i,IStart
         Type(One_UVFunction)     :: Current,Find_Largest_UVE
           
         Do i=1,B%NumUVE
            If(B%UVEG(i)%Title.eq.'#') Cycle
            Current=B%UVEG(i)
            k=i
            IStart=k+1
            Exit
         End Do 
         Do i=IStart,B%NumUVE
            If(B%UVEG(i)%Title.eq.'#') Cycle
            If(B%UVEG(i) .grth. Current) then
               Current=B%UVEG(i)
               k=i
            End If
         End Do
         Find_Largest_UVE=Current
      Return
      End 
C############################################################
      Subroutine ChangeIndicesUVE(UVE,From,To)
         Use ModUVE
         Implicit None
         Type(UVFunction)            :: A,UVE
         Integer                     :: From,To
         Integer k

         Do k=1,UVE%NumUVE
            If(UVE%UVEG(k)%Index(1).eq.From) 
     $      UVE%UVEG(k)%Index(1)=To
            If(UVE%UVEG(k)%Index(2).eq.From) 
     $      UVE%UVEG(k)%Index(2)=To 
         End Do
      Return
      End 
C############################################################
      Function ListVariablesUVE(A,Labl)
         Use ModUVE
         Use ModMom
         Implicit None
         Type(UVFunction)             :: A
         Type(List)                   :: ListVariablesUVE
         Type(List)                   :: ListVariables
         Integer i
         Character Labl

         ListVariablesUVE%Length=0
         If(A%NumUVE.eq.0) Return
         ListVariablesUVE 
     $   = ListVariables(A%UVEG(1)%Argument,Labl)
         Do i=2,A%NumUVE
            ListVariablesUVE = ListVariablesUVE 
     %      * ListVariables(A%UVEG(i)%Argument,Labl)
         End Do
         Call ShrinkList(ListVariablesUVE)
      Return
      End 
C############################################################
