      Subroutine ApplyP(Permut,ExpR)
C     Apply permutation Permut to ExpR%Oper and ExpR%UVE

      Use ModXpr
      Implicit None
      Type(Expression)    :: ExpR,A
      Integer,Dimension(nmaxOp+nmaxUV) :: Permut
      Integer i,j

C     Internal arrays
      Integer IPrint
      COMMON /Print/ IPrint

      A = ExpR
      Do i=1,ExpR%Oper%NumOp
         j=Permut(i)
         A%Oper%OperG(i) = ExpR%Oper%OperG(j)
      End Do
      Do i=1,ExpR%UVE%NumUVE
         j=Permut(i+ExpR%Oper%NumOp)-ExpR%Oper%NumOp
         A%UVE%UVEG(i) = ExpR%UVE%UVEG(j)
      End Do
      ExpR=A
    
      Return
      End
