      Subroutine BraExp(ExpR,Mass,Mode)
C     Apply the mass-shell condition (in Mass) to energy
C     ExpR if this will make energy 'smaller'
C     Mode ... 0 do not allow energy to be zero
C          ... 1 energy can be zero
      Use ModEnr
      Implicit None
      Type(Energy)         :: Mass,Add,Self,ExpR
      Integer Mode

      Self = ExpR

C     Add mass shell condition
      Add = Self + Mass
      If(Add%NumO.eq.0.and.Mode.eq.0) then
         ExpR = Self
         Return
      End If
      If(ExpR .grth. Add)  ExpR = Add

C     Subtract mass shell condition
      Add = Self - Mass
      If(Add%NumO.eq.0.and.Mode.eq.0) then
         ExpR = Self
         Return
      End If
      If(ExpR .grth. Add) ExpR = Add

      Return
      End
