      Function ChkTmp(Ex1,Ex2,ExpR,IStart)
      Use ModXpr
      Use ModTem
      Use ModOpr
      Implicit None
      Type(Operator)  :: Oper1,Oper2
      Type(Expression) Exp1,Exp2,Ex1,Ex2
      Logical ChkTmp, FitTmp

C     Internal arrays
      Type(Expression),Dimension(NumExp) :: ExpR
      Integer i,ii,j,IStart,IEnd
      Type(List) Temp, ExtractLabels

      Integer IPrint
      COMMON /Print/ IPrint

      ChkTmp=.false.
C     First check that we get correct order of the perturbation 
C     theory
  
      If((OrderN.gt.0).and.
     $   (Ex1%IPowr(4)+Ex2%IPowr(4).gt.OrderN)) Return
      If(NTempl.eq.0) then
         ChkTmp=.true.
         Return
      End If
      Oper1 = Ex1%Oper
      Oper2 = Ex2%Oper

      If(IPrint.ge.9) then
         Write(6,*)'NTempl = ',NTempl
         Do i=1,NTempl
            Write(6,*)Templt(i)%Length,
     $      Templt(i)%Body(:Templt(i)%Length)
         End Do
      End If

C     Generate all possible templates from the pair of
C     terms Oper1,Oper2

      Call ZeroEx(Exp1,Oper1)
      Call ZeroEx(Exp2,Oper2)

      Call GenTem(Exp1,Exp2,ExpR,IStart,IEnd)

      If(IPrint.ge.9) then
         Write(6,*) 'All templates '
         Do i=IStart,IEnd
            Temp=ExtractLabels(ExpR(i)%Oper)
            Write(6,*)Temp%Body(:Temp%Length)
         End Do
      End If

      Do i=IStart,IEnd
         If(FitTmp(ExpR(i)%Oper)) then
            ChkTmp=.true.
            Return 
         End If
      End Do

      Return
      End
