      Subroutine Intgrt(ii,ExpR)
      Use ModXpr
      Type(Expression), Dimension(NumExp) :: ExpR
      Type(Energy) Momen1
      Type(Energy)  Temp
      Integer ii
      Integer IType
      COMMON /Type/ IType

C     ii is position at which initial term is located
C     If this term has t-dependence then put T-term in
C     ii+1 and return ii+1 in place of ii
C     If this term has no t-dependence then return ii-1
C     in place of ii

      If(ExpR(ii)%Exponent%Expi(1)%NumO.eq.0) then
         Write(6,*) 'Warning!!! Term has no t-dependence!'
         ii=ii-1
         Return
      End If

C     First add a new bracket to DenomR

      If((ExpR(ii)%Oper%NumOp.eq.2).and.(ExpR(ii)%IPowr(8).eq.0)) then
C        Renorm term with no t-dependence
         ExpR(ii)%IPowr(8) = 1

      Else If((ExpR(ii)%Oper%NumOp.eq.2).and.(ExpR(ii)%IPowr(8).eq.1))
     $then
         ExpR(ii)%IPowr(8) = 0   
         ExpR(ii)%Denominator%NumDen
     $   = ExpR(ii)%Denominator%NumDen + 1
         ExpR(ii)%Denominator%Denom
     $   (ExpR(ii)%Denominator%NumDen) = ExpR(ii)%Exponent%Expi(1)
         ExpR(ii)%Denominator%NumDen
     $   = ExpR(ii)%Denominator%NumDen + 1
         ExpR(ii)%Denominator%Denom
     $   (ExpR(ii)%Denominator%NumDen) = ExpR(ii)%Exponent%Expi(1)
      Else 
C         Factor (-i) is included in the definition of the bracket
C         ExpR(ii)%IPowr(3)=ExpR(ii)%IPowr(3)+3
         ExpR(ii)%Denominator%NumDen
     $   = ExpR(ii)%Denominator%NumDen + 1
         ExpR(ii)%Denominator%Denom
     $   (ExpR(ii)%Denominator%NumDen) = ExpR(ii)%Exponent%Expi(1)
      End If
      If(IPrint.ge.9) Call Output(6,ExpR(ii),'After transform',ii)

      If(IType.eq.12) Return
C     Make another copy of the ii term in ii+1
      ii=ii+1
      ExpR(ii) = ExpR(ii-1)
      ExpR(ii)%IPowr(3)=ExpR(ii)%IPowr(3)+2
      ExpR(ii)%IPowr(8) = 0

C     Put in this term '-T' instead of '+t'
C                   or '+T' instead of '-t'
      ExpR(ii)%Exponent%Expi(2) = 
     $ExpR(ii)%Exponent%Expi(2) - ExpR(ii)%Exponent%Expi(1)
      ExpR(ii)%Exponent%Expi(1)%NumO = 0
      If(IPrint.ge.9) Call Output(6,ExpR(ii),'After transform',ii)

      Return
      End
