      Function MaShel(Oper)

C     Form a bracket containing mass shell energy expression
      Use ModOpr
      Use ModEnr
      Use ModLet
      Implicit None
      Type(Operator)    :: Oper
      Type(Energy)      :: MaShel
      Logical Creation_Operator,Destruction_Operator 
      Logical Electron_Operator,Positron_Operator,Photon_Operator
      Integer i

C     Internal arrays
      Integer IPrint
      COMMON /Print/ IPrint
C     What to do if term is not singly connected?
      MaShel%NumO=Oper%NumOp
      Do i=1,MaShel%NumO
         MaShel%Energies(i)%Momentum=Oper%OperG(i)%Argument
         If(Creation_Operator(Oper%OperG(i))) then
            MaShel%Energies(i)%Sign=1
         Else If(Destruction_Operator(Oper%OperG(i))) then
            MaShel%Energies(i)%Sign=-1
         End If

         If(Electron_Operator(Oper%OperG(i))
     $   .or.Positron_Operator(Oper%OperG(i))) then
            MaShel%Energies(i)%Title = 'Om'
         Else If(Photon_Operator(Oper%OperG(i))) then
            MaShel%Energies(i)%Title = 'Os'
         End If      
      End Do 
      Mashel%Sign = 1
 
      Call OrderEnergy(MaShel)
C      Call EnergySimplify(Mashel,i)      
C     Factor i is irrelevant in this case
      Return
      End
