      Subroutine OrdOpr(ExpR,IStart,IEnd)
C     Order operators in decreasing sequence. This is needed
C     for operators of similar type whose momenta are not independent,
C     so the correct order can not be established by procedure used
C     in Standr.
      Use ModXpR
      Implicit None
      Type(Expression) ExpR
      Type(Operator) A,C
      Integer IStart,IEnd,ISize,i,m
      Integer,Dimension(8) :: Permut
      Logical Parity,Fermion_Operator
      Type(One_Operator) Find_Smallest_Op

      ISize=IEnd-IStart+1
      If(ISize.lt.2) Return 
      A%NumOp=ISize
      Do i=IStart,IEnd
         A%OperG(i-IStart+1) = ExpR%Oper%OperG(i)
      End Do
 
      C%NumOp = ISize
      Do i=1,ISize
         C%OperG(i)=Find_Smallest_Op(A,m)
         Permut(i)=m
         A%OperG(m)%Title = '##'
      End Do
      Do i=IStart,IEnd
          ExpR%Oper%OperG(i) = C%OperG(i-IStart+1)
      End Do
      If(Fermion_Operator(ExpR%Oper%OperG(IStart)).and.
     $(.not.Parity(Permut,ISize))) ExpR%IPowr(3) = ExpR%IPowr(3) + 2

      Return
      End
      
