      Subroutine PntLst(Num,String,IPoint,Char,nmax,Len,Length)

C This subroutine creates a list of pointers to substrings Char in
C the string String
C  Input:
C       String
C       Length ... length of String
C       Char   ...  substring
C       Len     ... length of the substring Char (=2)
C 
C  Output
C       IPoint(nmax) ... array of pointers
C       Num               ... number of pointers      

      Character*(Length) String
      Character*(Len) Char
      Dimension IPoint(nmax)

      Num=0
      IStart = 1

      Do i=1,nmax

         IPoint(Num+1)= Index(String(IStart:Length),Char(1:Len))
         If (IPoint(Num+1).eq.0) Return
         IPoint(Num+1)= IPoint(Num+1)+IStart-1
C         Write(6,*)'IPoint(Num+1)=', IPoint(Num+1)
         IStart=IPoint(Num+1)+Len
         Num=Num+1
      End Do
      Write(6,*)' nmax is too small'
      Return
      End

