      Subroutine PreNum(Oper,UVE,MMin,MMax,IPermB,NNum,NumTot)
C     Prepare number arrays for use with permutations
      Use ModXpr
      Implicit None
      Type(Operator) Oper
      Type(UVFunction) UVE
      Integer,Dimension(8) :: MMin,MMax,IPermB,NNum
      Logical Electron_Creation,Electron_Destruction
      Logical Positron_Creation,Positron_Destruction
      Logical Photon_Creation,Photon_Destruction

C     Internal arrays
      Integer i,ii,k,kk,NumTot,NUmPer
      Integer IPrint
      COMMON /Print/ IPrint

      Call IClear(NNum,8)

      Do i=1,Oper%NumOp
         If     (Electron_Creation(Oper%OperG(i))) then
            NNum(1)=NNum(1)+1
         Else If(Electron_Destruction(Oper%OperG(i))) then
            NNum(2)=NNum(2)+1
         Else If(Positron_Creation(Oper%OperG(i))) then
            NNum(3)=NNum(3)+1
         Else If(Positron_Destruction(Oper%OperG(i))) then
            NNum(4)=NNum(4)+1
         Else If(Photon_Creation(Oper%OperG(i))) then
            NNum(5)=NNum(5)+1
         Else If(Photon_Destruction(Oper%OperG(i))) then
            NNum(6)=NNum(6)+1
         End If
      End Do
      Do i=1,UVE%NumUVE
         If(UVE%UVEG(i)%Title.eq.'U') then
            NNum(7)=NNum(7)+1
         Else If(UVE%UVEG(i)%Title.eq.'V') then
            NNum(8)=NNum(8)+1
         End If
      End Do

      If(IPrint.ge.9) then
C        NNum gives a list of numbers of operators in each 
C        group,i.e. NNum=(1,2,3,0,1,1)
         Write(6,*)'Array NNum'
         Do i=1,8
            Write(6,*)i,NNum(i)
         End Do
      End If
      Call IClear(IPermB,8)

C    Permutations for OperR
      NumTot = 1
      Do ii=1,8
         If(NNum(ii).le.1) then
            MMin(ii)=1
            MMax(ii)=1
            IPermB(ii)=1
         Else
            MMin(ii)=10**(NNum(ii)-1)
            MMax(ii)=10**NNum(ii)-1
C           NumPer is number of permutations in this sector
            NumPer=1
            Do kk=1,NNum(ii)
               NumPer = NumPer * kk
               k=NNum(ii)-kk
               IPermB(ii)=IPermB(ii)+kk*10**k
            End Do
            NumTot = NumTot * NumPer
         End If
      End Do

      Return
      End
