C############################################################
      Subroutine OrderGamma(A)
         Use ModGam
         Implicit None
         Type(Gamma)             :: A,B,C
         Type(One_Gamma) :: Find_Second_Largest,Find_Largest_Gam
         Integer kk,m,k

         C%NumGam=A%NumGam
         B=A
         kk=0
         Do k=1,A%NumGam/2
            kk = kk+1
            C%GamG(kk)=Find_Largest_Gam(B,m)
            B%GamG(m)%Label='#'
            kk = kk+1
            C%GamG(kk)=Find_Second_Largest(B,m,B%GamG(m)%Title)
            B%GamG(m)%Label='#'
         End Do
C        Now make labels of photon propagators grow in
C        alphabetical order
         Call OrderTitles(C)
         A = C
      Return
      End
C############################################################
      Function Find_Largest_Gam(B,k)
         Use ModGam
         Implicit None
         Type(Gamma)    :: B
         Integer        :: k,i,IStart
         Type(One_Gamma) :: Current,Find_Largest_Gam
            
         Do i=1,B%NumGam
            If(B%GamG(i)%Label.eq.'#') Cycle
            Current=B%GamG(i)
            k=i
            IStart=k+1
            Exit
         End Do
         Do i=IStart,B%NumGam
            If(B%GamG(i)%Label.eq.'#') Cycle
            If(B%GamG(i) .grth. Current) then
               Current=B%GamG(i)
               k=i
            End If
         End Do
         Find_Largest_Gam=Current
      Return
      End
C############################################################
      Function Find_Second_Largest(B,k,Tit)
         Use ModGam
         Implicit None
         Type(Gamma)    :: B
         Integer        :: i,k
         Type(One_Gamma) :: Find_Second_Largest
         Character Tit
            
         Do i=1,B%NumGam
            If(B%GamG(i)%Title.eq.Tit
     $      .and.B%GamG(i)%Label.ne.'#') then
               Find_Second_Largest=B%GamG(i)
               k=i
               Return
            End If
         End Do
      Return
      End 
C############################################################
      Subroutine OrderTitles(A)
         Use ModGam
         Implicit None
         Type(Gamma)    :: A
         Integer ii,i
         Character*1 Azbuka(18)
         Common/Azb/ Azbuka

         ii=0
         Do i=1,A%NumGam/2
            ii=ii+1
            A%GamG(ii)%Title = Azbuka(i)
            ii=ii+1
            A%GamG(ii)%Title = Azbuka(i)
         End Do
      Return
      End 
C############################################################
      Subroutine  Ampers(U)
C     Make all labels '*' in UVE3
         Use ModGam
         Implicit None
         Type(Gamma)                     ::  U
         Character Azbuka(18),Letter,Old_Title,Old_Label
         Integer i,j
         Common/Azb/ Azbuka

         Do i=1,U%NumGam
            If(U%GamG(i)%Label.eq.'$') then
               Old_Title=U%GamG(i)%Title
               Old_label=U%GamG(i)%Label
               Call FndLtr(Letter,U)
               Do j=1,U%NumGam
                  If(  U%GamG(j)%Title.eq.Old_Title
     $            .and.U%GamG(j)%Label.eq.Old_Label) then
                     U%GamG(j)%Title = Letter
                     U%GamG(j)%Label = '*'
                  End If
               End Do
            End If
         End Do
      Return
      End   
C############################################################
      Subroutine FndLtr(Let,Gam)
C        Find a letter that does not match any letter
C        used for labeling gamma matrices (with '*') in UVER
         Use ModGam
         Use ModLet
         Implicit None
         Type(Gamma)                     ::  Gam
         Integer i,ii
         Type(List) Momen
         Character Let,FindNewLetter

         ii=0
         Do i=1,Gam%NumGam
            If(Gam%GamG(i)%Label.eq.'*') then
               ii=ii+1
               Momen%Body(ii:ii)=Gam%GamG(i)%Title
            End If
         End Do
         Momen%Length=ii
         Call ShrinkList(Momen)

         Let=FindNewLetter(Momen)
      Return        
      End 
C############################################################
      Subroutine ChangeIndicesGam(Gam,From,To)
         Use ModGam
         Implicit None
         Type(Gamma)            :: Gam
         Integer                     :: From,To
         Integer k

         Do k=1,Gam%NumGam
            If(Gam%GamG(k)%Index(1).eq.From)
     $      Gam%GamG(k)%Index(1)=To
            If(Gam%GamG(k)%Index(2).eq.From)
     $      Gam%GamG(k)%Index(2)=To
         End Do
      Return
      End 
C############################################################
      Subroutine SubstituteLabelsGam(A,From,To)
         Use ModGam
         Implicit None
         Type(Gamma)            :: A
         Character                     :: From,To
         Integer i

         Do i=1,A%NumGam
            If(A%GamG(i)%Label.eq.From)
     $      A%GamG(i)%Label = To
         End Do
      Return
      End
C############################################################
